// Modul Fahrzeug.java
// Demonstriert Collection mit abgeleiteten Klassen + Reflection
// (Aufruf "virtueller" Funktionen)
// Benoetigt die Klassen Auto, Pkw, Lkw
// E.Huckert 05-2004
import java.util.*;
import java.lang.reflect.*;

public class Fahrzeug
{
  public static void main(String args[])
  {
    LinkedList ll = new LinkedList();
    //
    Pkw pkw1 = new Pkw();
    ll.add(pkw1);
    Pkw pkw2 = new Pkw(2500.0);
    ll.add(pkw2);
    Lkw lkw1 = new Lkw();
    ll.add(lkw1);
    //
    // Die Collection wieder auslesen und die jeweils richtige
    // Funktion getTyp() und steuern() aufrufen
    Iterator it      = ll.iterator();
    Auto auto        = null;
    String classname = null;
    while (it.hasNext())
    {
      auto = (Auto)it.next();
      System.out.println("Autotyp: " + auto.getTyp() +
                         " Steuern:" + auto.steuern());
      // Zeigt Benutzung des Operators instanceof 
      if (auto instanceof Lkw)
        System.out.println("\tdas issn LKW!");
      // 
      // Test Reflection
      Class c = auto.getClass();
      classname = c.getName();
      System.out.println("Klassenname ueber Reflection:" + classname);
    }
  }  // end main()
} 
