// Testprogramm fuer Collections
// Hier: Vector  
import java.util.*;

class coll1
{
  private Vector vec   = null;
 
  // Constructor
  public coll1()
  {
    // einen Vektor mit Anfangsgroesse 5 anlegen
    // bei jeder Vergroesserung sollen 10 Elemente neu angelegt werden
    vec = new Vector(5, 10);
  }
 
  // Anhaengen ans Ende des Vektors
  public void add(String s)
  { vec.add(s); }

  // Einfuegen an der genau bezeichneten Stelle 
  public void add(int i, String s)
  {
    try
    { 
      vec.add(i, s); 
    }
    catch (ArrayIndexOutOfBoundsException e)
    {
      System.out.println("Unzulaessiger Index: " + i);
    }
  }   // end add()

  // Holen des Elements mit Index i
  public String get(int i)
  { 
    try
    { 
      return (String)(vec.get(i)); 
    }
    catch (ArrayIndexOutOfBoundsException e)
    {
      System.out.println(e.getMessage() + "\nUnzulaessiger Index: " + i);
      return null;
    }
  }   // end get()

  // Loeschen eines Elements an der genau bezeichneten Stelle
  // Vorsicht: der (Pseudo)Array wird anschliessend komprimiert!
  public void remove(int i)
  {
    try
    { 
      String s = (String)(vec.remove(i)); 
    }
    catch (ArrayIndexOutOfBoundsException e)
    {
      System.out.println(e.getMessage() + "\nUnzulaessiger Index: " + i);
    }
  }   // end remove()

  public void zeigen() 
  {
    String eintrag = null;
    for (int i=0; i < vec.size(); i++)
    {
      //eintrag = (String)vec[i];   // geht nicht!!!
      eintrag = (String)(vec.get(i));
      System.out.println("Pos." + i + " " + eintrag);
    }
  }   // end zeigen()
 
  public static void main(String args[])
  {
    System.out.println("Test fuer Collection Vector");
    //
    coll1 coll = new coll1();
    //
    coll.add("null");  // Pos. 0
    coll.add("eins");  // Pos. 1
    coll.add("zwei");  // Pos. 2
    // wir provozieren hier eine ArrayIndexOutOfBoundsException
    coll.add(4, "vier"); // Pos. 4 - 3 lassen wir weg
    // wir provozieren eine Vergroesserung des Vektors
    coll.add(3, "drei");
    coll.add(4, "vier");
    coll.add(5, "fuenf");
    coll.add(6, "sechs");
    //
    coll.zeigen();
    // Einen Eintrag mitten drin loeschen
    System.out.println("Wir loeschen mitten drin");
    coll.remove(3);
    //
    coll.zeigen();
  }   // end main()
}

