// module console.java
// Testet einige Methoden und Klassen
// Copyright Dr.E.Huckert 02-2002


import java.util.*;
import java.io.*;
import java.text.*;

public class console  
{
  private boolean logging    = false;
  String          host       = null;
  int             port       = -1;
  public static   int stat   = 0;
  
  public void setLogging(boolean flag)
  {
    logging = flag;
  }   // end setLogging()

  public boolean getLogging()
  {
     return logging;
  }   // end getLogging()

  
  // the constructor
  public console()
  {
    setLogging(false);
    System.out.println("In Constructor");
  }   // end constructor 

  public String encode(String patt)
  {
    String ret = new String("");
    NumberFormat nf = NumberFormat.getInstance();
    nf.setParseIntegerOnly(true);
    nf.setGroupingUsed(false);
    nf.setMaximumFractionDigits(0);
    nf.setMinimumFractionDigits(0);
    nf.setMaximumIntegerDigits(3);
    nf.setMinimumIntegerDigits(3);
    for (int n=0; n < patt.length(); n++)
    {
      ret = ret + nf.format((int)patt.charAt(n));  
    }
    return ret;
  }   // end encode()
  
  public String hexEncode(String patt)
  {
    String ret = new String("");
    String hex = null;
    for (int n=0; n < patt.length(); n++)
    {
      hex = Integer.toHexString((int)patt.charAt(n));
      ret = ret + hex;
    }
    return ret;
  }

  public String hexDecode(String hex)
  {
    String ret = new String("");
    String aux = null;
    int i;
    Integer I;
    byte bar[];
    bar = new byte[20];
    int m = 0;
    for (int n=0; n < hex.length(); n += 2)
    {
      aux = hex.substring(n, n + 2);
      i   = Integer.parseInt(aux, 16);
      I   = new Integer(i);
      bar[m++] = I.byteValue();
    }
    ret = new String(bar);
    return ret;
  }

  /**
    * Decode a hex string (without leading "0x") into an int value
    */
  public int hex2Int(String hex)
  {
    int ret = Integer.parseInt(hex, 16);
    return ret;
  }   // end hex2Int()

  public static void printTime(GregorianCalendar cal)
  {
    int wert1, wert2,wert3, wert4, yy, mm, dd;
    yy = cal.get(Calendar.YEAR);
    mm = cal.get(Calendar.MONTH) + 1;
    dd = cal.get(Calendar.DAY_OF_MONTH);
    wert1 = cal.get(Calendar.HOUR_OF_DAY);
    wert2 = cal.get(Calendar.MINUTE);
    wert3 = cal.get(Calendar.SECOND);
    wert4 = cal.get(Calendar.MILLISECOND);
    System.out.println("Datum + Zeit:" + yy + "-" + mm  + "-" + dd + " " + 
                        wert1 + ":" + wert2 + 
                        ":" + wert3 + ":" + wert4); 
  }

  public static void main(String args[])
  {
    String s1 = null;
    String s2 = null;
    String s3 = null;
    String ret = null;
    //
    console obj1 = new console();
    obj1.setLogging(true);
    //
    s1 = new String("abcdefgABCDEFG0123");
    System.out.println("\ns1=" + s1);
    ret = obj1.encode(s1);
    System.out.println("encoded s1=" + ret);
    //
    // Hexadezimal Kodierung und Dekodierung
    s2 = obj1.hexEncode(s1);
    System.out.println("Hex encoded s1=" + s2);
    s1 = obj1.hexDecode(s2);
    System.out.println("decoded from hex s2=" + s2 + ":" + s1);
    //
    GregorianCalendar cal = new GregorianCalendar();
    console.printTime(cal);
    cal.roll(Calendar.HOUR_OF_DAY, -1);
    console.printTime(cal);
    //
    // Test Manipulation des Datumsfeldes "Tag" 
    for (int n=0; n < 5; n++)
    {
      //cal.roll(Calendar.DAY_OF_MONTH, -1);
      cal.add(Calendar.DATE, -1);
      console.printTime(cal);
    }  
    //
    int i = obj1.hex2Int("aabbcc");
    System.out.println("aus Hex aabbcc dekodiert:" + i);
    i = obj1.hex2Int("123456");
    System.out.println("aus Hex 123456 dekodiert:" + i);
 
    // Test statische Klassenvariablen
    console obj2 = new console();
    System.out.println("console.stat=" + 
                        console.stat + " obj1.stat=" + obj1.stat + 
                                       " obj2.stat=" + obj2.stat);
    obj1.stat = 2;
    System.out.println("nach Zuweisung: console.stat=" + 
                        console.stat + " obj1.stat=" + obj1.stat + 
                                       " obj2.stat=" + obj2.stat);

    // Test > mit Strings
    // geht nicht!!!
    //if ("abc" > "ABC")
    //  System.out.println("abc > ABC"); 

    // Test casts mit Zahlen
    double d1 = 17.755;
    int    i1 = 2;
    double d2 = i1 * d1;
    System.out.println("Double Wert d2=" + d2);
    //int    i2 = i1 * d1;   // geht nicht!!!
    int    ix = (int)(i1 * d1);   
    System.out.println("int Wert ix=" + ix);

  }   // end main()
}
