// Das ist eine kleine Applikation
// die einen einfachen Weg aufzeigt,
// wie Widgets in einem GUI interagieren.
// Neben einem JTextField  und einer
// JTextArea wird noch ein ActionListener
// dem Text-Feld hinzugefuegt. Damit wird
// die Zeile des Text-Feldes der TextArea
// hinzugefuegt
// In Anlehnung an Schulz: Beispiel 33
// In diesem Beispiel sind die "inner class" absichtlich eliminiert
// und als normale Klasse in HuSwingWL ausgelagert

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class HuSwing extends JFrame 
  implements ActionListener
{
  static final int WIDTH=350;
  static final int HEIGHT=180;
  
  JTextField textField;
  JTextArea textList;
  JScrollPane pane;
 
  final boolean logging = true;
 
  public boolean getLogging()
  {  return logging; }

  public HuSwing(String lab) 
  {
    super (lab);
    setBackground(Color.lightGray);
    
    // Erzeugen eines Containers fuer das TextFeld 
    JPanel textPanel = new JPanel();
    
    // Eine Border (Umrahmung) setzen
    // Defaultmaessig haben Panels keine Border
    textPanel.setBorder (BorderFactory. createEtchedBorder());
    
    textPanel.setLayout(new BorderLayout());
    
    JLabel textTitle = new JLabel("Text und Enter");
    textPanel.add(textTitle, BorderLayout.NORTH);
    textField = new JTextField();
    textPanel.add(textField, BorderLayout.SOUTH);
    
    // Ein strut TextPanel hinzufuegen als 
    // unterer Rand
    textPanel.add(Box.createVerticalStrut(6));
    
    // Erzeugen eines Container fuer textArea 
    JPanel listPanel = new JPanel();
    listPanel.setBorder (BorderFactory. createEtchedBorder());
    listPanel.setLayout(new BoxLayout (listPanel,BoxLayout.Y_AXIS));
    JLabel title = new JLabel("Text Liste");
    listPanel.add(title);
    listPanel.add(Box.createVerticalStrut(10));	
    
    textList=new JTextArea("", 6, 10);
    textList.setEditable(false);
    pane = new JScrollPane(textList);
    listPanel.add(pane);
    listPanel.add(Box.createVerticalStrut(6));
    
    // Einen Listener dem textField hinzufuegen
    textField.addActionListener(this);
    
    Container c = getContentPane();
    c.setLayout (new FlowLayout());
    c.add (textPanel);
    c.add (Box.createHorizontalStrut(30));
    c.add (listPanel);
  }  
  
  public void actionPerformed(ActionEvent e) 
  {
     // Append the textField's text to textList
     textList.append(textField.getText());
     textList.append("\n");
     pane.validate();
     textField.setText("");
     if (logging) System.out.println("in actionPerformed()");
  }  // end actionPerformed()

  public static void main(String args[]) 
  {
    HuSwing frame = new HuSwing("Swing HuSwing");
    HuSwingWL wl  = new HuSwingWL();
    frame.addWindowListener(wl); 
    frame.setSize(WIDTH, HEIGHT);
    frame.setVisible(true);
  }   // end main()
}
