// Testprogramm fuer JAVA Strings
// Testet Klasse StringBuffer
// Beispiel fuer Auswertung der command line Argumente
// Dr. E.Huckert 02-02-2001 


import java.util.*;
import java.text.*;

public class testString 
{
  private String s1 = null;
  private String s2 = null;
  private boolean logging = false;

  //  Constructor
  public testString(String str1,
                    String str2)
  {
    s1 = str1;
    s2 = str2;
  }

  public void setLogging(boolean flag)
  {
    logging = flag;
  }

  // Get the specified field from a string
  // Returns: a field as a string
  public String getField(String row,
                         int fieldno,   // starting from 0!!!
                         char sep)
  {
    StringBuffer field = new StringBuffer(1024);
    field.setLength(0);
    int    nof   = 0;
    for (int n = 0; n < row.length(); n++)
    {
      if (row.charAt(n) == sep)
      {
        nof++;
        if (nof > fieldno)
          break;
        else
          field.setLength(0);
      }
      else
      {
        if (nof == fieldno)
          field.append(row.charAt(n));
      }
    }   // for n ...
    return field.toString();
  }   // end getField()

  // Testet auf Gleichheit der Pointer
  public void test1(String str1, String str2)
  {
    if (str1 == str2)
      System.out.println("Stringpointer sind gleich:" + str1 + "?" + str2);
    else
      System.out.println("Stringpointer sind ungleich:" + str1 + "?" + str2);
  }

  // Testet auf Gleichheit der Strings 
  public void test2(String str1, String str2)
  {
    if (str1.equals(str2))
      System.out.println("Strings sind gleich:" + str1 + "?" + str2);
    else
      System.out.println("Strings sind ungleich:" + str1 + "?" + str2);
  }

  public void test3(String str1, String str2)
  {
    // Laenge ermitteln
    int ls = str1.length();
    System.out.println("Laenge:" + str1 + "=" + ls);
    // Verkettung zweier Strings
    String s3 = str1 + str2;
    System.out.println("Verkettung:" + str1 + " " + str2 + "=" + s3);
    // Zugriff auf ein einzelnes Zeichen
    char ch = str1.charAt(1);
    System.out.println("Zeichen #1 aus " + str1 + "=" + ch);
    // Substring 
    s3 = str1.substring(1); 
    System.out.println("Substring ab Pos.1 von " + str1 + "=" + s3);
  }

  private void test4a(String s)
  {
     s = s + " geaendert";
  }

  // Test, ob Strings im UP veraendert werden koennen
  // Ergebnis: String wird durch Aufruf nicht geaendert!
  public void test4(String s)
  {
    System.out.println("test4: s=" + s);
    test4a(s);
    System.out.println("test4 nach test4a: s=" + s);
  }

  // Testet Klasse StringBuffer ueber Routine getField()
  public void test5(String s, int no_field)
  {
    System.out.println("test5: Feld1=" + getField(s, no_field, '|'));
  }

  public void run()
  {
    // 
    test1(s1, s1);
    test1(s1, s2);
    test1(s1, "abc");
    //
    test2(s1, s2);
    s2 = "abc";
    test2(s1, s2);
    //
    test3("123", "456");
    //
    test4("abcdefg");
    //
    test5("Edgar|Huckert|Goldbach|", 1);
  }   // end run()

  // Hauptprogramm
  public static void main(String args[])
  {
    // Auswertung command line Argumente
    testString ts = new testString("abc", "def");
    for (int n=0; n < args.length; n++)
    {
      if (args[n].equals("-v"))
        ts.setLogging(true);
    }
    //
    ts.run();
  }
}
