// module HUDom1.java
//
import javax.xml.parsers.DocumentBuilder; 
import javax.xml.parsers.DocumentBuilderFactory;  
import javax.xml.parsers.FactoryConfigurationError;  
import javax.xml.parsers.ParserConfigurationException;
import org.xml.sax.SAXException;  
import org.xml.sax.SAXParseException;  
import java.io.File;
import java.io.IOException;
import org.w3c.dom.Document;
import org.w3c.dom.DOMException;

public class HUDom1
{
    // Global value so it can be ref'd by the tree-adapter
    static Document document1;
    static Document document2;

    public static void main(String argv[])
    {
        if (argv.length <  2) 
        {
          System.err.println("Usage: java HUDom1 filename1.xml filename2.xml");
          System.exit(1);
        }

        DocumentBuilderFactory factory =
            DocumentBuilderFactory.newInstance();
        factory.setValidating(true);   
        factory.setNamespaceAware(true);
        try 
        {
           DocumentBuilder builder = factory.newDocumentBuilder();
           // Dokument 1 parsen
           System.out.println("Dokument 1 wird geparst:" + argv[0]);
           document1 = builder.parse(new File(argv[0]));
           // Dokument 2 parsen
           System.out.println("Dokument 2 wird geparst:" + argv[1]);
           document2 = builder.parse(new File(argv[1]));
        }
        catch (SAXParseException spe) 
        {
           // Error generated by the parser
           System.out.println("\n** Parsing error"
              + ", line " + spe.getLineNumber()
              + ", uri " + spe.getSystemId());
           System.out.println("   " + spe.getMessage() );

           // Use the contained exception, if any
           Exception  x = spe;
           if (spe.getException() != null)
               x = spe.getException();
           x.printStackTrace();
        }
        catch (SAXException sxe) 
        {
           // Error generated during parsing)
           Exception  x = sxe;
           if (sxe.getException() != null)
               x = sxe.getException();
           x.printStackTrace();
        }
        catch (ParserConfigurationException pce) 
        {
            // Parser with specified options can't be built
            pce.printStackTrace();
        }
        catch (IOException ioe) 
        {
           // I/O error
           ioe.printStackTrace();
        }
    }    // main
}
