// module Jdom2CanonicalString
// E.Huckert 6-2004
 
// DOM und SAX imports
import javax.xml.parsers.*; 
import javax.xml.transform.*; 
import javax.xml.transform.dom.*; 
import javax.xml.transform.stream.*; 
import org.xml.sax.SAXException;  
import org.xml.sax.SAXParseException;  
import java.io.File;
import java.io.IOException;
import org.w3c.dom.*;

// JDOM imports
import org.jdom.*;
import org.jdom.input.SAXBuilder;
import org.jdom.output.*;
//
import java.io.*;
import java.util.*;

public class Jdom2CanonicalString
{
  public static org.jdom.Document jdomDocument   = null;
  public static org.w3c.dom.Document domDocument = null;

  public static void main(String args[])
  {
    if (args.length < 1)
    {
      System.out.println("Usage: jdom2dom XMLdocument");
      System.exit(0);
    }

    // ein XML Dokument parsen und als JDOM Document vorhalten
    SAXBuilder saxBuilder = new SAXBuilder();
    try
    {
      jdomDocument = saxBuilder.build(args[0]);
    }
    catch (Exception e)
    { 
      System.out.println("Ausnahme:" + e.getMessage());
      System.exit(1);
    }  
  
    // JDOM Document in DOM Document konvertieren (hier nicht benoetigt)
    // Das JDOM Document auf stdout ausgeben
    try 
    {
      //DOMOutputter domout = new DOMOutputter();
      //domout.output(jdomDocument);
      // Das JDOM Document auf stdout ausgeben
      //XMLOutputter xmlout = new XMLOutputter(); 
      // kein Ident, keine Newlines!
      Format format = Format.getCompactFormat(); 
      XMLOutputter xmlout = new XMLOutputter(format); 
      //xmlout.setTrimText(true);  // das ist in der JDOM Doku falsch
      //xmlout.setTextTrim(true);
      //xmlout.setNewlines(false);
      String xmls = xmlout.outputString(jdomDocument);
      System.out.println("XML Dokument als String=" + xmls);
    }
    catch (Exception e)
    {
      System.out.println("Ausnahme:" + e.getMessage());
      System.exit(3);
    }
  }   // end main()
} 
