// module DateiKopie1.java
// Kopiert eine Datei in eine andere Datei
// E.Huckert 01-2002

import java.io.*;
import java.util.*;

public class DateiKopie1
{
  String ifn = null;
  String ofn = null;
  BufferedReader fr = null;
  BufferedWriter fw = null;

  // Constructor
  // Merkt sich Inp. und Outputdateiname
  public DateiKopie1(String inpfn, String outfn)
  {
    ifn = inpfn;
    ofn = outfn;
  }

  // eventuell offene Dateien schliessen
  void closeAll()
  {
    try
    {
      if (fr != null) fr.close();
      if (fw != null) fw.close();
    }
    catch (IOException e)
    {
      System.out.println("IO Ausnahme: " + e.getMessage());
    }
  }   // end closeAll()

  // Hier wird kopiert
  // Liefert -1 im Fehlerfall
  // Liefert sonst die Zahl der kopierten Zeilen
  int run()
  {
    int nolines = 0;
    String zeile = null;
    try
    {
      fr = new BufferedReader(new FileReader(ifn));  
      fw = new BufferedWriter(new FileWriter(ofn));
      while ((zeile = fr.readLine()) != null)
      {
        // CR und LF sind beim Lesen eliminiert worden!
        fw.write(zeile);
        fw.newLine();
        nolines++;
        //System.out.println(zeile);
      }
      closeAll();
    }
    catch (IOException e)
    {
      closeAll();
      System.out.println("IO Ausnahme: " + e.getMessage());
      nolines = -1;   // als Fehlerflag
    }
    return nolines;
  }   // end run()

  public static void main(String args[])
  {
    if (args.length < 2)
    {
       System.out.println("Aufruf: java DateiKopie1 quelldatei zieldatei");
       System.exit(0);
    }
    DateiKopie1 dk = new DateiKopie1(args[0], args[1]);
    int nolines = dk.run();
    System.out.println("Anzahl kop. Zeilen=" + nolines);
  }   // end main()
}

