// module DateiKopie2.java
// Kopie2rt eine Datei in eine andere Datei
// Auch fuer Binaerdateien geeignet!
// E.Huckert 01-2002

import java.io.*;
import java.util.*;

public class DateiKopie2
{
  String ifn = null;
  String ofn = null;
  RandomAccessFile ifd = null;
  RandomAccessFile ofd = null;

  // Constructor
  // Merkt sich Inp. und Outputdateiname
  public DateiKopie2(String inpfn, String outfn)
  {
    ifn = inpfn;
    ofn = outfn;
  }

  // eventuell offene Dateien schliessen
  void closeAll()
  {
    try
    {
      if (ifd != null) ifd.close();
      if (ofd != null) ofd.close();
    }
    catch (IOException e)
    {
      System.out.println("IO Ausnahme: " + e.getMessage());
    }
  }   // end closeAll()

  // Hier wird kopiert
  // Liefert -1 im Fehlerfall
  // Liefert sonst die Zahl der kopierten Bytes
  int run()
  {
    int ret     = 0;
    int nobytes = 0;
    byte[] barr = new byte[512];
    try
    {
      ifd = new RandomAccessFile(ifn, "r");
      ofd = new RandomAccessFile(ofn, "rw");
      while (true)
      {
        ret = ifd.read(barr);
        if (ret <= 0) break;
        ofd.write(barr, 0, ret); 
        nobytes += ret;
      }
      closeAll();
    }
    catch (IOException e)
    {
      closeAll();
      System.out.println("IO Ausnahme: " + e.getMessage());
      nobytes = -1;   // als Fehlerflag
    }
    return nobytes;
  }   // end run()

  public static void main(String args[])
  {
    if (args.length < 2)
    {
       System.out.println("Aufruf: java DateiKopie2 quelldatei zieldatei");
       System.exit(0);
    }
    DateiKopie2 dk = new DateiKopie2(args[0], args[1]);
    int nobytes = dk.run();
    System.out.println("Anzahl kop. Zeichen=" + nobytes);
  }   // end main()
}

