// module directory.java
// Testet Dateien und Verzeichnisse
// Fuehrt ein externes Kommando aus Java aus
// (Hier das Dumpkommand "xxd")
// Sammelt den Output, den das externe Kommando erzeugt und gibt
// den Output ueber System.out.println() aus
// Copyright Dr.E.Huckert 11-2002

import java.util.*;
import java.io.*;

public class directory  
{
  private boolean logging    = false;
  
  public void setLogging(boolean flag)
  {
    logging = flag;
  }   // end setLogging()

  public boolean getLogging()
  {
     return logging;
  }   // end getLogging()
  
  // the constructor
  public directory()
  {
    setLogging(false);
  }   // end constructor 

  public void ausfuehren(String datei)
  {
    java.lang.Runtime rt = java.lang.Runtime.getRuntime();
    try
    {
      StringBuffer outp = new StringBuffer(4096);
      StringBuffer err  = new StringBuffer(4096);
      //
      // Aufruf externes Kommando
      System.out.println("Ausfuehrung Kommando: xxd " + datei);
      java.lang.Process p = rt.exec("xxd " + datei);
      //
      // Sammeln des Outputs, der durch das externe Kommando erzeugt wird
      String  line = null;
      BufferedReader is = new BufferedReader(
                                new InputStreamReader(
                                    p.getInputStream()));
      BufferedReader es = new BufferedReader(
                                new InputStreamReader(
                                    p.getErrorStream()));
      while ((line = is.readLine()) != null)
         outp.append(line + "\n");
      while ((line = es.readLine()) != null)
         err.append(line + "\n");
      int ret = p.waitFor();
      ret     = p.exitValue();
      //
      System.out.println("exit value=" + ret);
      System.out.println("stdout des Kommandos:" + outp.toString());
      System.out.println("stderr des Kommandos:" + err.toString());
    }
    catch (InterruptedException ie)
    {
      System.out.println("InterruptedException message=" + ie.getMessage());
    }
    catch (IOException ie)
    {
      System.out.println("IOException message=" + ie.getMessage());
    }
  }   // end ausfuehren()

  public static void main(String args[])
  {
    if (args.length < 1)
    {
      System.out.println("Aufruf: java directory verzeichnis");
      System.exit(1);
    }
    directory obj = new directory();
    obj.setLogging(true);
    try
    {
      // Dateien im Unterverzeichnis ausgeben
      String verzname = args[0];
      File verz = new File(verzname);
      if (verz.isDirectory())
      {
        String dateien[] = verz.list();
        for (int n=0; n < dateien.length; n++)
        {
          System.out.println("Datei:" + dateien[n]);
          File f = new File(verzname + "/" + dateien[n]);
          if (f.exists())
          {
            System.out.println("  Pfad:" + f.getPath());
            System.out.println("  Absoluter Pfad:" + f.getAbsolutePath());
            System.out.println("  Zuletzt geaendert:" + 
                                 (new Date(f.lastModified())));
            //
            obj.ausfuehren(f.getAbsolutePath());
          }
          else
            System.out.println("  Datei existiert nicht!");
        }
      }
    }
    catch (Exception e)
    {
      System.out.println("Exception message=" + e.getMessage());
    }
  }   // end main()
}
